import sys 
import re

def wsadminToList(inStr): 
        outList=[] 
        if (len(inStr)>0 and inStr[0]=='[' and inStr[-1]==']'): 
                tmpList = inStr[1:-1].split(" ") 
        else: 
                tmpList = inStr.split("\n")  #splits for Windows or Linux 
        for item in tmpList: 
                item = item.rstrip();        #removes any Windows "\r" 
                if (len(item)>0): 
                        outList.append(item) 
        return outList 
#endDef 

def replace(inStr,rrdiDir,insightDir): 
		outList=""
		newVal=""
		tmpList = inStr.split(":")  #splits by : 
		for item in tmpList:
		#string contains "AppServer" will not be replaced.
				if (item.find('AppServer')==-1):
						newVal = item.replace(rrdiDir,insightDir)
				else:
						newVal = item
				outList+=newVal
				outList+=':'
		#endFor
		
		outList=outList[0:len(outList)-1]
		return outList 
#endDef 


if (len(sys.argv)!=4):
		sys.exit(1)
else:
		serverName = sys.argv[0]
		insightDir= sys.argv[1]
		rrdiDir= sys.argv[2]
		os= sys.argv[3]
		
		if(insightDir[len(insightDir)-1]=='/'):
				insightDir = insightDir[0:(len(insightDir)-1)]
		if(rrdiDir[len(rrdiDir)-1]=='/'):
				rrdiDir = rrdiDir[0:(len(rrdiDir)-1)]

		srvid = AdminConfig.getid('/Server:'+serverName+'/JavaProcessDef:/')
		envirnmntEntries = AdminConfig.showAttribute(srvid, "environment")
		entryList = wsadminToList(envirnmntEntries) 
  
		if (len(envirnmntEntries) != '[]'): 
        
				for entry in entryList: 
						varName = AdminConfig.showAttribute(entry, "name") 
						varVal = AdminConfig.showAttribute(entry, "value")
						if(os=='unix'):
								newVal = replace(varVal,rrdiDir,insightDir)
						if(os=='windows'):
								newVal = varVal.replace(rrdiDir,insightDir)
						#construct the new name:value pair
						attrList = [['name', varName], ['value', newVal]]
						#update the value
						AdminConfig.modify(entry, attrList)
				#endFor 
		#endIf 
		AdminConfig.save()
